package com.zhongzheng.modules.order.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.modules.order.bo.OrderInputTemplateAddBo;
import com.zhongzheng.modules.order.bo.OrderInputTemplateEditBo;
import com.zhongzheng.modules.order.bo.OrderInputTemplateQueryBo;
import com.zhongzheng.modules.order.domain.OrderInputTemplate;
import com.zhongzheng.modules.order.mapper.OrderInputTemplateMapper;
import com.zhongzheng.modules.order.service.IOrderInputTemplateService;
import com.zhongzheng.modules.order.vo.OrderInputTemplateVo;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 订单采集信息模板Service业务层处理
 *
 * @author hjl
 * @date 2021-11-05
 */
@Service
public class OrderInputTemplateServiceImpl extends ServiceImpl<OrderInputTemplateMapper, OrderInputTemplate> implements IOrderInputTemplateService {

    @Override
    public OrderInputTemplateVo queryById(Long id){
        OrderInputTemplate db = this.baseMapper.selectById(id);
        return BeanUtil.toBean(db, OrderInputTemplateVo.class);
    }

    @Override
    public List<OrderInputTemplateVo> queryList(OrderInputTemplateQueryBo bo) {
        LambdaQueryWrapper<OrderInputTemplate> lqw = Wrappers.lambdaQuery();
        lqw.eq(StrUtil.isNotBlank(bo.getType()), OrderInputTemplate::getType, bo.getType());
        lqw.like(StrUtil.isNotBlank(bo.getName()), OrderInputTemplate::getName, bo.getName());
        lqw.eq(bo.getStatus() != null, OrderInputTemplate::getStatus, bo.getStatus());
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<OrderInputTemplateVo> entity2Vo(Collection<OrderInputTemplate> collection) {
        List<OrderInputTemplateVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, OrderInputTemplateVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<OrderInputTemplate> page = (Page<OrderInputTemplate>)collection;
            Page<OrderInputTemplateVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(OrderInputTemplateAddBo bo) {
        OrderInputTemplate add = BeanUtil.toBean(bo, OrderInputTemplate.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(OrderInputTemplateEditBo bo) {
        OrderInputTemplate update = BeanUtil.toBean(bo, OrderInputTemplate.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(OrderInputTemplate entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
